//+------------------------------------------------------------------+
//|                                                  MTConnector.mqh |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                         https://www.mql5.com/ru/users/nikolay7ko |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Nikolay Semko"
#property link      "https://www.mql5.com/ru/users/nikolay7ko"
#property link      "SemkoNV@bk.ru"  
#property version   "1.01"

#import "user32.dll"
bool GetWindowTextA(int hwnd,uchar &name[],int nChars=255);
bool SetWindowTextA(int hwnd,uchar &name[]);
int  GetWindowTextLengthA(int hwnd);
int  GetDesktopWindow();
#import
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct CurInfo
  {
   double            ask;
   double            bid;
   datetime          OpenTime;
   datetime          CurTime;
   datetime          LocalTime;
   double            high;
   double            low;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
union CInfo
  {
   CurInfo           ci;
   uchar             a[56];
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class MTConnector
  {
private:
   CInfo             U;
   int               h;
public:
                     MTConnector();
                    ~MTConnector();
   void              SendNewTick();
   void              GetNewTick();
   CurInfo           CurInf;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MTConnector::MTConnector()
  {
   h=GetDesktopWindow();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MTConnector::~MTConnector()
  {
  }
//+------------------------------------------------------------------+

void MTConnector::SendNewTick()
  {
   MqlTick tick;
   MqlRates rate[1];
   SymbolInfoTick(_Symbol,tick);
   CopyRates(_Symbol,PERIOD_M1,0,1,rate);
   U.ci.CurTime=TimeCurrent();
   U.ci.OpenTime=rate[0].time;;
   U.ci.LocalTime=TimeLocal();
   U.ci.ask=tick.ask;
   U.ci.bid=tick.bid;
   U.ci.high = rate[0].high;
   U.ci.low  = rate[0].low;
   uchar m[112]; ArrayInitialize(m,1);
   for(int i=0; i<56; i++) if(U.a[i]==0) m[2*i+1]=2; else m[2*i]=U.a[i];
   SetWindowTextA(h,m);
   CurInf=U.ci;
  }
//+------------------------------------------------------------------+
void MTConnector::GetNewTick()
  {
   int j=GetWindowTextLengthA(h);
   uchar m[112];
   if(j==113) if(GetWindowTextA(h,m,j+1))
      for(int i=0; i<56; i++) if(m[2*i+1]==1) U.a[i]=m[2*i]; else U.a[i]=0;
   CurInf=U.ci;
  }
//+------------------------------------------------------------------+
